controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\helpers\Html;
use yii\data\ActiveDataProvider;
use app\models\Prendas;
use app\models\Categorias;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        $fotos= Prendas::find()->where(['portada'=>1])->all();
        foreach($fotos as $foto)
        {
            $carousel[]=[
            'content' => Html::img("@web/imgs/$foto->foto",["height"=>300,"width"=>200]),
            'caption' =>"<p style=color:blue class=bg-white>{$foto->precio}€</p>" . Html::a("Ver",["site/verprenda", 'id' => $foto->id], ['class' => 'btn btn-primary']),
        ];
        }
        
        $dataProvider = new ActiveDataProvider([
        'query' => Prendas::find()->where(['portada'=>1])]);
        $dataProvider1 = new ActiveDataProvider([
        'query' => Prendas::find()->where(['oferta'=>1])]);
        return $this->render('index',["carousel" => $carousel, "dataProvider" => $dataProvider, "dataProvider1" => $dataProvider1]);
    }
    
    public function actionVercategoria($tipo,$subtipo)
    {
        $categoria=Categorias::find()->where(['tipo'=>$tipo,'subtipo'=>$subtipo])->one();
        $dataProvider = new ActiveDataProvider([
        'query' => $categoria->getPrendas()]);
        return $this->render('vercategoria',["tipo" => $tipo, "subtipo" => $subtipo, "dataProvider" => $dataProvider]);
    }
    
    public function actionVercategoriatipo($tipo)
    {
        $categorias= Categorias::find()->where(['tipo'=>$tipo])->all();
        $idCategorias=[];
        foreach($categorias as $categoria)
        {
            $idCategorias[]=$categoria->id;
        }
        $dataProvider = new ActiveDataProvider([
        'query' => Prendas::find()->where(['id_categorias'=>$idCategorias])]);
        return $this->render('vercategoria',["tipo" => $tipo, "subtipo" => "todo", "dataProvider" => $dataProvider]);
    }
    
    /*
     * Esta accion muestra los datos de cada prenda
     */
    public function actionVerprenda($id)
    {
        $prenda= Prendas::findOne($id);
        return $this->render('verprenda',["prenda" => $prenda]);  
    }
    
    public function actionOfertas()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Prendas::find()->where(['oferta'=>1])]);
        return $this->render('ofertas',["dataProvider" => $dataProvider, "migas" => true]); 
    }
    
    public function actionDestacados()
    {
        $categorias= Categorias::find()->select('tipo')->distinct()->all();
        return $this->render('destacados',["categorias" => $categorias]); 
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
           ['label' => 'Hombre', 'items' =>[
                ['label' => 'Cazadoras', 'url' => ['/site/vercategoria','tipo'=>'hombre','subtipo'=>'cazadoras']],
                ['label' => 'Pantalones', 'url' => ['/site/vercategoria','tipo'=>'hombre','subtipo'=>'pantalones']],
                ['label' => 'Sudaderas', 'url' => ['/site/vercategoria','tipo'=>'hombre','subtipo'=>'sudaderas']]]],
            ['label' => 'Mujer', 'items' =>[
                ['label' => 'Abrigos', 'url' => ['/site/vercategoria','tipo'=>'mujer','subtipo'=>'abrigos']],
                ['label' => 'Pantalones', 'url' => ['/site/vercategoria','tipo'=>'mujer','subtipo'=>'pantalones']],
                ['label' => 'Faldas', 'url' => ['/site/vercategoria','tipo'=>'mujer','subtipo'=>'faldas']]]],
            ['label' => 'Niños', 'url' => ['/site/vercategoria','tipo'=>'niño','subtipo'=>'todo']],
            ['label' => 'Ofertas', 'url' => ['/site/ofertas']],
            ['label' => 'Destacados', 'url' => ['/site/destacados']],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">&copy; My Company <?= date('Y') ?></p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>